﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Lab3
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        VertexDeclaration vd;
        VertexPositionColor[] vertices;
        int[] indices;

        VertexPositionColor[] axis;
        int[] axisIndices;

        BasicEffect effect;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            effect = new BasicEffect(GraphicsDevice, null);

            vd = new VertexDeclaration(GraphicsDevice, VertexPositionColor.VertexElements);
            vertices = new VertexPositionColor[8];


            // Цвета для вершин задавать необязательно, так как цвет будет задан при отрисовке
            vertices[0].Position = new Vector3(-0.5f, 0.5f, 0.5f);
            vertices[1].Position = new Vector3(0.5f, 0.5f, 0.5f);
            vertices[2].Position = new Vector3(0.5f, -0.5f, 0.5f);
            vertices[3].Position = new Vector3(-0.5f, -0.5f, 0.5f);


            vertices[4].Position = new Vector3(0.5f, 0.5f, -0.5f);
            vertices[5].Position = new Vector3(-0.5f, 0.5f, -0.5f);
            vertices[6].Position = new Vector3(-0.5f, -0.5f, -0.5f);
            vertices[7].Position = new Vector3(0.5f, -0.5f, -0.5f);

            indices = new int[] {
                0, 1, 2, 2, 3, 0,
                4, 5, 6, 6, 7, 4,
                2, 1, 4, 4, 7, 2,
                6, 5, 0, 0, 3, 6,
                1, 0, 5, 5, 4, 1,
                3, 2, 7, 7, 6, 3
            };

            axis = new VertexPositionColor[4];

            axis[0].Position = Vector3.Zero;
            axis[1].Position = new Vector3(3, 0, 0);
            axis[2].Position = new Vector3(0, 3, 0);
            axis[3].Position = new Vector3(0, 0, 3);

            axisIndices = new int[] { 0, 1, 0, 2, 0, 3};
            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.Black);


            // Включение каркасного режима отображения
            GraphicsDevice.RenderState.FillMode = FillMode.WireFrame;
            // Выключение отбраковки невидимых вершин
            GraphicsDevice.RenderState.CullMode = CullMode.None;

            // TODO: Add your drawing code here
            Matrix world = Matrix.Identity;//Matrix.CreateRotationY((float)gameTime.TotalGameTime.TotalSeconds);
            
            Matrix view = Matrix.CreateLookAt(new Vector3(0.5f, 1, 5), Vector3.Zero, Vector3.Up);
            Matrix proj = Matrix.CreatePerspectiveFieldOfView(MathHelper.ToRadians(45), GraphicsDevice.Viewport.AspectRatio, 1, 10);

            GraphicsDevice.VertexDeclaration = vd;

            effect.World = world;
            effect.View = view;
            effect.Projection = proj;
            
            effect.DiffuseColor = new Vector3(1, 1, 1);

            effect.Begin();
            foreach (EffectPass pass in effect.CurrentTechnique.Passes)
            {
                pass.Begin();
                GraphicsDevice.DrawUserIndexedPrimitives<VertexPositionColor>(PrimitiveType.LineList, axis, 0, axis.Length, axisIndices, 0, axisIndices.Length / 2);
                pass.End();
            }
            effect.End();

            effect.Begin();
            effect.DiffuseColor = new Vector3(1, 0, 1);
            foreach (EffectPass pass in effect.CurrentTechnique.Passes)
            {
                pass.Begin();
                GraphicsDevice.DrawUserIndexedPrimitives<VertexPositionColor>(PrimitiveType.TriangleList, vertices, 0, vertices.Length, indices, 0, indices.Length / 3);
                pass.End();
            }
            effect.End();

            effect.World = Matrix.CreateTranslation(0, 1, 0);
            effect.Begin();
            effect.DiffuseColor = new Vector3(1, 0, 0);
            foreach (EffectPass pass in effect.CurrentTechnique.Passes)
            {
                pass.Begin();
                GraphicsDevice.DrawUserIndexedPrimitives<VertexPositionColor>(PrimitiveType.TriangleList, vertices, 0, vertices.Length, indices, 0, indices.Length / 3);
                pass.End();
            }
            effect.End();


            effect.World = Matrix.CreateScale(2);
            effect.Begin();
            effect.DiffuseColor = new Vector3(0, 1, 0);
            foreach (EffectPass pass in effect.CurrentTechnique.Passes)
            {
                pass.Begin();
                GraphicsDevice.DrawUserIndexedPrimitives<VertexPositionColor>(PrimitiveType.TriangleList, vertices, 0, vertices.Length, indices, 0, indices.Length / 3);
                pass.End();
            }
            effect.End();

            base.Draw(gameTime);
        }
    }
}
